#! /bin/bash
set -e

echo "installing ovs"
sudo apt-get install -y openvswitch-switch

echo "installing wget"
sudo apt-get install -y wget


echo "installing ovs-docker"
cd /usr/bin
sudo wget https://raw.githubusercontent.com/openvswitch/ovs/master/utilities/ovs-docker

echo "changing ovs-docker permissions"
sudo chmod a+rwx ovs-docker

echo "Fixup address so that RAN uses docker bridge for license check"
docker exec -ti qslice_qslice_1 bash -c 'sed -i "s@localipaddress=.*@localipaddress=$(hostname --ip-address)@" /usr/ran/ran.cfg'


echo "setup ovs bridge = mwc-br1"
sudo ovs-vsctl add-br mwc-br1
sudo ifconfig mwc-br1 10.42.1.1 netmask 255.255.0.0 up

echo "adding port of qslice"
sudo ovs-docker add-port mwc-br1 eth0 qslice_qslice_1 --ipaddress=10.42.11.120/16 --gateway=10.42.1.1

echo "adding port of qfabric"
sudo ovs-docker add-port mwc-br1 eth0 qfabric_qfabric_1 --ipaddress=10.42.11.1/16 --gateway=10.42.1.1

sudo ovs-vsctl add-port mwc-br1 eth1

echo "ovs install and setup complete"
