from charms.docker import Compose
from charms.templating.jinja2 import render
from charmhelpers.core.hookenv import config
from charmhelpers.core.hookenv import open_port
from charmhelpers.core.hookenv import status_set
from charms.reactive import when, when_not, set_state
from charms.docker import Docker


@when_not('qfabric.configured')
def check_configuration():
    required_keys = ['distribution-user',
                     'distribution-pass',
                     'distribution-email']
    for k in required_keys:
        if not config(k):
            status_set("blocked", "Missing config option {}".format(k))
            return

    set_state('qfabric.configured')

@when('docker.available', 'qfabric.configured')
def run_epic():
    # authenticate to private docker repository
    d = Docker()
    cfg = config()
    d.login(cfg['distribution-user'], cfg['distribution-pass'],
            cfg['distribution-email'])

    # Render the template
    render('docker-compose.yml', 'files/qfabric/docker-compose.yml', cfg)

    comp = Compose('files/qfabric')
    comp.up()
